#include "m32c-87.h"
#include "pmclock.h"

#define LED p10

#ifdef CLOCK_20MHz
#define CLOCK_HZ 20000000
#endif
#ifdef CLOCK_125KHz
#define CLOCK_HZ 125000
#endif

#ifndef CLOCK_HZ
#error Set one of the clock speeds in clock.h
#endif

#define swaps(x) (((x)<<8) | ((x)>>8))

/* These are based on a 1000 Hz internal timer.  */
extern volatile unsigned int  tics;
extern volatile unsigned long tics_long;
extern int wait_ms (int);


static inline void set_dmd0 (word v) { asm volatile ("ldc %0,dmd0" : : "g" (v)); }
static inline void set_dct0 (word v) { asm volatile ("ldc %0,dct0" : : "g" (v)); }
static inline void set_drc0 (word v) { asm volatile ("ldc %0,drc0" : : "g" (v)); }
static inline void set_dma0 (volatile void *v) { asm volatile ("ldc %0,dma0" : : "g" (v)); }
static inline void set_dsa0 (volatile void *v) { asm volatile ("ldc %0,dsa0" : : "g" (v)); }
static inline void set_dra0 (volatile void *v) { asm volatile ("ldc %0,dra0" : : "g" (v)); }

static inline void set_dmd1 (word v) { asm volatile ("ldc %0,dmd1" : : "g" (v)); }
static inline void set_dct1 (word v) { asm volatile ("ldc %0,dct1" : : "g" (v)); }
static inline void set_drc1 (word v) { asm volatile ("ldc %0,drc1" : : "g" (v)); }
static inline void set_dma1 (volatile void *v) { asm volatile ("ldc %0,dma1" : : "g" (v)); }
static inline void set_dsa1 (volatile void *v) { asm volatile ("ldc %0,dsa1" : : "g" (v)); }
static inline void set_dra1 (volatile void *v) { asm volatile ("ldc %0,dra1" : : "g" (v)); }

static inline word get_dmd0 (void) { word rv; asm volatile ("stc dmd0,%0" : "=g" (rv)); return rv; }
static inline word get_dmd1 (void) { word rv; asm volatile ("stc dmd1,%0" : "=g" (rv)); return rv; }
